--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -5928,7 +6211,7 @@
                     format = GL2.GL_BGRA;
                     type = GL2.GL_UNSIGNED_INT_8_8_8_8_REV;
                     break;
-                    /* This method only supports 3 and 4 components formats and INT types. */
+                /* This method only supports 3 and 4 components formats and INT types. */
                 case ImageComponentRetained.TYPE_BYTE_LA:
                 case ImageComponentRetained.TYPE_BYTE_GRAY:
                 case ImageComponentRetained.TYPE_USHORT_GRAY:
@@ -5941,16 +6224,15 @@
                     return;
             }
             /* Force Alpha to 1.0 if needed */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 0.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 1.0f);
             }
 
             IntBuffer buf = null;
-            if(dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
+            if (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
                 buf = IntBuffer.wrap((int[]) data);
-            }
-            else {
+            } else {
                 buf = (IntBuffer) data;
             }
 
@@ -5960,7 +6242,7 @@
                     format, type, buf);
 
             /* Restore Alpha scale and bias */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 1.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 0.0f);
             }
@@ -5976,9 +6258,9 @@
     }
 
     void updateTextureFilterModes(Context ctx,
-            int target,
-            int minFilter,
-            int magFilter) {
+                                  int target,
+                                  int minFilter,
+                                  int magFilter) {
         GL gl = context(ctx).getGL();
 
         if (EXTRA_DEBUGGING) {
@@ -6065,14 +6347,14 @@
     }
 
     void updateTextureBoundary(Context ctx,
-            int target,
-            int boundaryModeS,
-            int boundaryModeT,
-            int boundaryModeR,
-            float boundaryRed,
-            float boundaryGreen,
-            float boundaryBlue,
-            float boundaryAlpha) {
+                               int target,
+                               int boundaryModeS,
+                               int boundaryModeT,
+                               int boundaryModeR,
+                               float boundaryRed,
+                               float boundaryGreen,
+                               float boundaryBlue,
+                               float boundaryAlpha) {
         GL gl = context(ctx).getGL();
 
         // set texture wrap parameter
@@ -6148,43 +6430,10 @@
         }
     }
 
-    private static final String getFilterName(int filter) {
-        switch (filter) {
-            case Texture.FASTEST:
-                return "Texture.FASTEST";
-            case Texture.NICEST:
-                return "Texture.NICEST";
-            case Texture.BASE_LEVEL_POINT:
-                return "Texture.BASE_LEVEL_POINT";
-            case Texture.BASE_LEVEL_LINEAR:
-                return "Texture.BASE_LEVEL_LINEAR";
-            case Texture.MULTI_LEVEL_POINT:
-                return "Texture.MULTI_LEVEL_POINT";
-            case Texture.MULTI_LEVEL_LINEAR:
-                return "Texture.MULTI_LEVEL_LINEAR";
-            case Texture.FILTER4:
-                return "Texture.FILTER4";
-            case Texture.LINEAR_SHARPEN:
-                return "Texture.LINEAR_SHARPEN";
-            case Texture.LINEAR_SHARPEN_RGB:
-                return "Texture.LINEAR_SHARPEN_RGB";
-            case Texture.LINEAR_SHARPEN_ALPHA:
-                return "Texture.LINEAR_SHARPEN_ALPHA";
-            case Texture2D.LINEAR_DETAIL:
-                return "Texture.LINEAR_DETAIL";
-            case Texture2D.LINEAR_DETAIL_RGB:
-                return "Texture.LINEAR_DETAIL_RGB";
-            case Texture2D.LINEAR_DETAIL_ALPHA:
-                return "Texture.LINEAR_DETAIL_ALPHA";
-            default:
-                return "(unknown)";
-        }
-    }
-
     private void updateTextureSharpenFunc(Context ctx,
-            int target,
-            int numPts,
-            float[] pts) {
+                                          int target,
+                                          int numPts,
+                                          float[] pts) {
         // checking of the availability of sharpen texture functionality
         // is already done in shared code
 // FIXME: GL_SGIS_sharpen_texture
@@ -6193,9 +6442,9 @@
     }
 
     private void updateTextureFilter4Func(Context ctx,
-            int target,
-            int numPts,
-            float[] pts) {
+                                          int target,
+                                          int numPts,
+                                          float[] pts) {
         // checking of the availability of filter4 functionality
         // is already done in shared code
 // FIXME: GL_SGIS_texture_filter4
@@ -6204,22 +6453,6 @@
 //                numPts, pts, 0);
     }
 
-    // mapping from java enum to gl enum
-    private static final int[] _gl_textureCubeMapFace = {
-        GL.GL_TEXTURE_CUBE_MAP_POSITIVE_X,
-        GL.GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
-        GL.GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
-        GL.GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
-        GL.GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
-        GL.GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
-    };
-
-    // ---------------------------------------------------------------------
-
-    //
-    // MasterControl methods
-    //
-
     // Maximum lights supported by the native API
     @Override
     int getMaximumLights() {
@@ -6230,111 +6463,102 @@
         return 8;
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // Canvas3D methods - native wrappers
-    //
-
     // Mac/JRE 7; called from Renderer when resizing is dedected
     // Implementation follows the approach in jogamp.opengl.GLDrawableHelper.resizeOffscreenDrawable(..)
     @Override
     void resizeOffscreenLayer(Canvas3D cv, int cvWidth, int cvHeight) {
-		if (!isOffscreenLayerSurfaceEnabled(cv))
-			return;
+        if (!isOffscreenLayerSurfaceEnabled(cv))
+            return;
+
+        JoglDrawable joglDrawable = (JoglDrawable) cv.drawable;
+        if (!hasFBObjectSizeChanged(joglDrawable, cvWidth, cvHeight))
+            return;
+
+        int newWidth = Math.max(1, cvWidth);
+        int newHeight = Math.max(1, cvHeight);
 
-		JoglDrawable joglDrawable = (JoglDrawable)cv.drawable;
-		if (!hasFBObjectSizeChanged(joglDrawable, cvWidth, cvHeight))
-			return;
-
-		int newWidth = Math.max(1, cvWidth);
-		int newHeight = Math.max(1, cvHeight);
-
-		GLDrawable glDrawble = joglDrawable.getGLDrawable();
-		GLContext glContext = context(cv.ctx);
-
-		// Assuming glContext != null
-
-		final NativeSurface surface = glDrawble.getNativeSurface();
-	    final ProxySurface proxySurface = (surface instanceof ProxySurface) ? (ProxySurface)surface : null;
-
-		final int lockRes = surface.lockSurface();
-
-		try {
-			// propagate new size - seems not relevant here
-			if (proxySurface != null) {
-				final UpstreamSurfaceHook ush = proxySurface.getUpstreamSurfaceHook();
-				if (ush instanceof UpstreamSurfaceHook.MutableSize) {
-					((UpstreamSurfaceHook.MutableSize)ush).setSurfaceSize(newWidth, newHeight);
-				}
-			}
+        GLDrawable glDrawble = joglDrawable.getGLDrawable();
+        GLContext glContext = context(cv.ctx);
+
+        // Assuming glContext != null
+
+        final NativeSurface surface = glDrawble.getNativeSurface();
+        final ProxySurface proxySurface = (surface instanceof ProxySurface) ? (ProxySurface) surface : null;
+
+        final int lockRes = surface.lockSurface();
+
+        try {
+            // propagate new size - seems not relevant here
+            if (proxySurface != null) {
+                final UpstreamSurfaceHook ush = proxySurface.getUpstreamSurfaceHook();
+                if (ush instanceof UpstreamSurfaceHook.MutableSize) {
+                    ((UpstreamSurfaceHook.MutableSize) ush).setSurfaceSize(newWidth, newHeight);
+                }
+            }
 			/*else if(DEBUG) { // we have to assume surface contains the new size already, hence size check @ bottom
 	              System.err.println("GLDrawableHelper.resizeOffscreenDrawable: Drawable's offscreen surface n.a. ProxySurface, but "+ns.getClass().getName()+": "+ns);
 			}*/
 
-			GL2 gl = glContext.getGL().getGL2();
+            GL2 gl = glContext.getGL().getGL2();
 
-			// FBO : should be the default case on Mac OS X
-			if (glDrawble instanceof GLFBODrawable) {
+            // FBO : should be the default case on Mac OS X
+            if (glDrawble instanceof GLFBODrawable) {
 
-				// Resize GLFBODrawable
-				// TODO msaa gets lost
+                // Resize GLFBODrawable
+                // TODO msaa gets lost
 //				((GLFBODrawable)glDrawble).resetSize(gl);
 
-				// Alternative: resize GL_BACK FBObject directly,
-				// if multisampled the FBO sink (GL_FRONT) will be resized before the swap is executed
-				int numSamples = ((GLFBODrawable)glDrawble).getChosenGLCapabilities().getNumSamples();
-				FBObject fboObjectBack = ((GLFBODrawable)glDrawble).getFBObject( GL.GL_BACK );
-				fboObjectBack.reset(gl, newWidth, newHeight, numSamples/*, false*/); // false = don't reset SamplingSinkFBO immediately
-				fboObjectBack.bind(gl);
-
-				// If double buffered without antialiasing the GL_FRONT FBObject
-				// will be resized by glDrawble after the next swap-call
-			}
-			// pbuffer - not tested because Mac OS X 10.7+ supports FBO
-			else {
-				// Create new GLDrawable (pbuffer) and update the coresponding GLContext
-
-				final GLContext currentContext = GLContext.getCurrent();
-				final GLDrawableFactory factory = glDrawble.getFactory();
-
-				// Ensure to sync GL command stream
-				if (currentContext != glContext) {
-					glContext.makeCurrent();
-				}
-	         	gl.glFinish();
-	         	glContext.release();
-
-	         	if (proxySurface != null) {
-	         		proxySurface.enableUpstreamSurfaceHookLifecycle(false);
-	         	}
-
-	         	try {
-	         		glDrawble.setRealized(false);
-	         		// New GLDrawable
-	         		glDrawble = factory.createGLDrawable(surface);
-	         		glDrawble.setRealized(true);
-
-	         		joglDrawable.setGLDrawable(glDrawble);
-	         	}
-	         	finally {
-	         		if (proxySurface != null) {
-	         			proxySurface.enableUpstreamSurfaceHookLifecycle(true);
-	         		}
-	         	}
-
-	         	glContext.setGLDrawable(glDrawble, true); // re-association
-
-	         	// make current last current context
-	         	if (currentContext != null) {
-	         		currentContext.makeCurrent();
-	         	}
-			}
-		}
-		finally {
-			surface.unlockSurface();
-		}
+                // Alternative: resize GL_BACK FBObject directly,
+                // if multisampled the FBO sink (GL_FRONT) will be resized before the swap is executed
+                int numSamples = ((GLFBODrawable) glDrawble).getChosenGLCapabilities().getNumSamples();
+                FBObject fboObjectBack = ((GLFBODrawable) glDrawble).getFBObject(GL.GL_BACK);
+                fboObjectBack.reset(gl, newWidth, newHeight, numSamples/*, false*/); // false = don't reset SamplingSinkFBO immediately
+                fboObjectBack.bind(gl);
+
+                // If double buffered without antialiasing the GL_FRONT FBObject
+                // will be resized by glDrawble after the next swap-call
+            }
+            // pbuffer - not tested because Mac OS X 10.7+ supports FBO
+            else {
+                // Create new GLDrawable (pbuffer) and update the coresponding GLContext
+
+                final GLContext currentContext = GLContext.getCurrent();
+                final GLDrawableFactory factory = glDrawble.getFactory();
+
+                // Ensure to sync GL command stream
+                if (currentContext != glContext) {
+                    glContext.makeCurrent();
+                }
+                gl.glFinish();
+                glContext.release();
+
+                if (proxySurface != null) {
+                    proxySurface.enableUpstreamSurfaceHookLifecycle(false);
+                }
+
+                try {
+                    glDrawble.setRealized(false);
+                    // New GLDrawable
+                    glDrawble = factory.createGLDrawable(surface);
+                    glDrawble.setRealized(true);
+
+                    joglDrawable.setGLDrawable(glDrawble);
+                } finally {
+                    if (proxySurface != null) {
+                        proxySurface.enableUpstreamSurfaceHookLifecycle(true);
+                    }
+                }
+
+                glContext.setGLDrawable(glDrawble, true); // re-association
+
+                // make current last current context
+                if (currentContext != null) {
+                    currentContext.makeCurrent();
+                }
+            }
+        } finally {
+            surface.unlockSurface();
+        }
     }
 
     // Fix for Bug 983
@@ -6350,7 +6574,7 @@
             if (appContextClass.getMethod("getAppContext").invoke(null) == null) {
                 final Field field = appContextClass.getDeclaredField("threadGroup2appContext");
                 field.setAccessible(true);
-                final Map threadGroup2appContext = (Map)field.get(null);
+                final Map threadGroup2appContext = (Map) field.get(null);
                 final ThreadGroup currentThreadGroup = Thread.currentThread().getThreadGroup();
                 threadGroup2appContext.put(currentThreadGroup, mainThreadContext);
             }
@@ -6364,41 +6588,39 @@
     // This is the native method for creating the underlying graphics context.
     @Override
     Context createNewContext(Canvas3D cv, Drawable drawable,
-            Context shareCtx, boolean isSharedCtx,
-            boolean offScreen) {
+                             Context shareCtx, boolean isSharedCtx,
+                             boolean offScreen) {
         if (VERBOSE) System.err.println("JoglPipeline.createNewContext()");
 
         checkAppContext();
-	    GLDrawable	glDrawable 	= null;
-	    GLContext 	glContext	= null;
+        GLDrawable glDrawable = null;
+        GLContext glContext = null;
 
-	    if (offScreen) {
-	    	glDrawable = drawable(cv.drawable); // cv.drawable != null, set in 'createOffScreenBuffer'
-			glContext = glDrawable.createContext(context(shareCtx));
-        }
-	    else {
-	    	// determined in 'getBestConfiguration'
-			GraphicsConfigInfo gcInf0 = Canvas3D.graphicsConfigTable.get(cv.graphicsConfiguration);
-			AWTGraphicsConfiguration awtConfig = (AWTGraphicsConfiguration)gcInf0.getPrivateData();
-
-		    // JAWTWindow
-			JAWTWindow nativeWindow = (JAWTWindow)NativeWindowFactory.getNativeWindow(cv, awtConfig);
-			nativeWindow.lockSurface();
-		    try {
-	    		glDrawable = GLDrawableFactory.getFactory(profile).createGLDrawable(nativeWindow);
-	    		glContext = glDrawable.createContext(context(shareCtx));
-		    }
-		    finally {
-		    	nativeWindow.unlockSurface();
-		    }
+        if (offScreen) {
+            glDrawable = drawable(cv.drawable); // cv.drawable != null, set in 'createOffScreenBuffer'
+            glContext = glDrawable.createContext(context(shareCtx));
+        } else {
+            // determined in 'getBestConfiguration'
+            GraphicsConfigInfo gcInf0 = Canvas3D.graphicsConfigTable.get(cv.graphicsConfiguration);
+            AWTGraphicsConfiguration awtConfig = (AWTGraphicsConfiguration) gcInf0.getPrivateData();
+
+            // JAWTWindow
+            JAWTWindow nativeWindow = (JAWTWindow) NativeWindowFactory.getNativeWindow(cv, awtConfig);
+            nativeWindow.lockSurface();
+            try {
+                glDrawable = GLDrawableFactory.getFactory(profile).createGLDrawable(nativeWindow);
+                glContext = glDrawable.createContext(context(shareCtx));
+            } finally {
+                nativeWindow.unlockSurface();
+            }
 
-	    	cv.drawable = new JoglDrawable(glDrawable, nativeWindow);
+            cv.drawable = new JoglDrawable(glDrawable, nativeWindow);
         }
 
         // assuming that this only gets called after addNotify has been called
-    	glDrawable.setRealized(true);
+        glDrawable.setRealized(true);
 
-    	// Apparently we are supposed to make the context current at this point
+        // Apparently we are supposed to make the context current at this point
         // and set up a bunch of properties
 
         // Work around for some low end graphics driver bug, such as Intel Chipset.
@@ -6415,8 +6637,7 @@
                 ++failCount;
                 try {
                     Thread.sleep(100);
-                }
-                catch (InterruptedException e) {
+                } catch (InterruptedException e) {
                 }
             }
         } while (failed && (failCount < MAX_FAIL_COUNT));
@@ -6434,7 +6655,7 @@
                 throw new IllegalRenderingStateException("Unable to fetch properties from current OpenGL context");
             }
 
-            if(!isSharedCtx){
+            if (!isSharedCtx) {
                 // Set up fields in Canvas3D
                 setupCanvasProperties(cv, ctx, gl);
             }
@@ -6466,41 +6687,39 @@
             // Mac OS X / JRE 7 : onscreen rendering = offscreen rendering
             // bind FBO
             if (!offScreen && glDrawable instanceof GLFBODrawable) {
-            	GLFBODrawable fboDrawable = (GLFBODrawable)glDrawable;
-            	// bind GLFBODrawable's drawing FBObject
-            	// GL_BACK returns the correct FBOObject for single/double buffering, incl. multisampling
-            	fboDrawable.getFBObject( GL.GL_BACK ).bind(gl);
+                GLFBODrawable fboDrawable = (GLFBODrawable) glDrawable;
+                // bind GLFBODrawable's drawing FBObject
+                // GL_BACK returns the correct FBOObject for single/double buffering, incl. multisampling
+                fboDrawable.getFBObject(GL.GL_BACK).bind(gl);
             }
 
 
             // FBO or pbuffer
             if (offScreen) {
 
-            	// Final caps
-            	GLCapabilitiesImmutable chosenCaps = glDrawable.getChosenGLCapabilities();
+                // Final caps
+                GLCapabilitiesImmutable chosenCaps = glDrawable.getChosenGLCapabilities();
 
-            	// FBO
-            	if (glDrawable instanceof GLFBODrawable) {
-                	GLFBODrawable fboDrawable = (GLFBODrawable)glDrawable;
-                	// bind GLFBODrawable's drawing FBObject
-                	// GL_BACK returns the correct FBOObject for single/double buffering, incl. multisampling
-                	fboDrawable.getFBObject( GL.GL_BACK ).bind(gl);
-            	}
-            	// pbuffer
-            	else {
-	            	// Double buffering: read from back buffer, as we don't swap
-					// Even this setting is identical to the initially mode it is set explicitly
-					if (chosenCaps.getDoubleBuffered()) {
-						gl.glReadBuffer(GL.GL_BACK);
-					}
-					else {
-						gl.glReadBuffer(GL.GL_FRONT);
-					}
-            	}
+                // FBO
+                if (glDrawable instanceof GLFBODrawable) {
+                    GLFBODrawable fboDrawable = (GLFBODrawable) glDrawable;
+                    // bind GLFBODrawable's drawing FBObject
+                    // GL_BACK returns the correct FBOObject for single/double buffering, incl. multisampling
+                    fboDrawable.getFBObject(GL.GL_BACK).bind(gl);
+                }
+                // pbuffer
+                else {
+                    // Double buffering: read from back buffer, as we don't swap
+                    // Even this setting is identical to the initially mode it is set explicitly
+                    if (chosenCaps.getDoubleBuffered()) {
+                        gl.glReadBuffer(GL.GL_BACK);
+                    } else {
+                        gl.glReadBuffer(GL.GL_FRONT);
+                    }
+                }
             }
-        }
-        finally {
- 			glContext.release();
+        } finally {
+            glContext.release();
         }
 
         return ctx;
@@ -6508,20 +6727,20 @@
 
     @Override
     void createQueryContext(Canvas3D cv, Drawable drawable,
-            boolean offScreen, int width, int height) {
+                            boolean offScreen, int width, int height) {
         if (VERBOSE) System.err.println("JoglPipeline.createQueryContext()");
 
         // Assumes createQueryContext is never called for a drawable != null
 
         if (offScreen) {
 
-         	Drawable offDrawable = createOffScreenBuffer(cv, null, width, height);
+            Drawable offDrawable = createOffScreenBuffer(cv, null, width, height);
 
-         	GLDrawable glDrawable = drawable(offDrawable);
+            GLDrawable glDrawable = drawable(offDrawable);
 
-        	glDrawable.setRealized(true);
+            glDrawable.setRealized(true);
 
-    		GLContext glContext = glDrawable.createContext(null);
+            GLContext glContext = glDrawable.createContext(null);
             glContext.makeCurrent();
 
             JoglContext ctx = new JoglContext(glContext);
@@ -6536,44 +6755,42 @@
             // Done !
 
             glContext.release();
-    		glContext.destroy();
-    		glDrawable.setRealized(false);
-    	}
-        else {
-
-        	// TODO can't find an implementation which avoids the use of QueryCanvas
-        	// JOGL requires a visible Frame for an onscreen context
-
-        Frame f = new Frame();
-        f.setUndecorated(true);
-        f.setLayout(new BorderLayout());
-
-        ContextQuerier querier = new ContextQuerier(cv);
-
-		    AWTGraphicsConfiguration awtConfig =
-		    		(AWTGraphicsConfiguration)Canvas3D.graphicsConfigTable.get(cv.graphicsConfiguration).getPrivateData();
-
-		    QueryCanvas canvas = new QueryCanvas(awtConfig, querier);
-
-        f.add(canvas, BorderLayout.CENTER);
-        f.setSize(MIN_FRAME_SIZE, MIN_FRAME_SIZE);
-        f.setVisible(true);
-        canvas.doQuery();
-        // Attempt to wait for the frame to become visible, but don't block the EDT
-        if (!EventQueue.isDispatchThread()) {
-            synchronized(querier) {
-                if (!querier.done()) {
-                    try {
-                        querier.wait(WAIT_TIME);
-	                    }
-	                    catch (InterruptedException e) {
+            //glContext.destroy();
+            glDrawable.setRealized(false);
+        } else {
+
+            // TODO can't find an implementation which avoids the use of QueryCanvas
+            // JOGL requires a visible Frame for an onscreen context
+
+            Frame f = new Frame();
+            f.setUndecorated(true);
+            f.setLayout(new BorderLayout());
+
+            ContextQuerier querier = new ContextQuerier(cv);
+
+            AWTGraphicsConfiguration awtConfig =
+                    (AWTGraphicsConfiguration) Canvas3D.graphicsConfigTable.get(cv.graphicsConfiguration).getPrivateData();
+
+            QueryCanvas canvas = new QueryCanvas(awtConfig, querier);
+
+            f.add(canvas, BorderLayout.CENTER);
+            f.setSize(MIN_FRAME_SIZE, MIN_FRAME_SIZE);
+            f.setVisible(true);
+            canvas.doQuery();
+            // Attempt to wait for the frame to become visible, but don't block the EDT
+            if (!EventQueue.isDispatchThread()) {
+                synchronized (querier) {
+                    if (!querier.done()) {
+                        try {
+                            querier.wait(WAIT_TIME);
+                        } catch (InterruptedException e) {
+                        }
                     }
                 }
             }
-        }
 
-        disposeOnEDT(f);
-    }
+            disposeOnEDT(f);
+        }
     }
 
     // This is the native for creating an offscreen buffer
@@ -6584,36 +6801,36 @@
         // ctx unused, doesn't exist yet
 
         // Offscreen Canvas3D's JoglGraphicsConfiguration
-        JoglGraphicsConfiguration jgc = (JoglGraphicsConfiguration)cv.graphicsConfiguration;
+        JoglGraphicsConfiguration jgc = (JoglGraphicsConfiguration) cv.graphicsConfiguration;
 
         // Retrieve the offscreen Canvas3D's GraphicsConfigInfo
-		GraphicsConfigInfo gcInf0 = Canvas3D.graphicsConfigTable.get(jgc);
+        GraphicsConfigInfo gcInf0 = Canvas3D.graphicsConfigTable.get(jgc);
 
-		// Offscreen Canvas3D's graphics configuration, determined in 'getBestConfiguration'
-		AWTGraphicsConfiguration awtConfig = (AWTGraphicsConfiguration)gcInf0.getPrivateData();
+        // Offscreen Canvas3D's graphics configuration, determined in 'getBestConfiguration'
+        AWTGraphicsConfiguration awtConfig = (AWTGraphicsConfiguration) gcInf0.getPrivateData();
 
-		// TODO Offscreen Canvas3D's graphics devise, determined in 'getBestConfiguration'
-		//AbstractGraphicsDevice device = awtConfig.getScreen().getDevice();			// throws exception
-		// Alternative: default graphics device
+        // TODO Offscreen Canvas3D's graphics devise, determined in 'getBestConfiguration'
+        //AbstractGraphicsDevice device = awtConfig.getScreen().getDevice();			// throws exception
+        // Alternative: default graphics device
         AbstractGraphicsDevice device = GLDrawableFactory.getDesktopFactory().getDefaultDevice();
 
-		// Offscreen Canvas3D's capabilites, determined in 'getBestConfiguration'
-		GLCapabilities canvasCaps = (GLCapabilities)awtConfig.getChosenCapabilities();
+        // Offscreen Canvas3D's capabilites, determined in 'getBestConfiguration'
+        GLCapabilities canvasCaps = (GLCapabilities) awtConfig.getChosenCapabilities();
 
-		// For further investigations : the user's GraphicsConfigTemplate3D (not used yet)
-		GraphicsConfigTemplate3D gct3D = gcInf0.getGraphicsConfigTemplate3D();
+        // For further investigations : the user's GraphicsConfigTemplate3D (not used yet)
+        GraphicsConfigTemplate3D gct3D = gcInf0.getGraphicsConfigTemplate3D();
 
 
         // Assuming that the offscreen drawable will/can support the chosen GLCapabilities
-    	// of the offscreen Canvas3D
+        // of the offscreen Canvas3D
 
         final GLCapabilities offCaps = new GLCapabilities(profile);
         offCaps.copyFrom(canvasCaps);
 
         // double bufffering only if scene antialiasing is required/preferred and supported
         if (offCaps.getSampleBuffers() == false) {
-        	offCaps.setDoubleBuffered(false);
-        	offCaps.setNumSamples(0);
+            offCaps.setDoubleBuffered(false);
+            offCaps.setNumSamples(0);
         }
 
         // Never stereo
@@ -6621,11 +6838,11 @@
 
         // Set preferred offscreen drawable : framebuffer object (FBO) or pbuffer
         offCaps.setFBO(true); // switches to pbuffer if FBO is not supported
-		// caps.setPBuffer(true);
+        // caps.setPBuffer(true);
 
-		// !! a 'null' capability chooser; JOGL doesn't call a chooser for offscreen drawable
+        // !! a 'null' capability chooser; JOGL doesn't call a chooser for offscreen drawable
 
-		// If FBO : 'offDrawable' is of type com.jogamp.opengl.GLFBODrawable
+        // If FBO : 'offDrawable' is of type com.jogamp.opengl.GLFBODrawable
         GLDrawable offDrawable = GLDrawableFactory.getFactory(profile).createOffscreenDrawable(device, offCaps, null, width, height);
 
 // !! these chosen caps are not final as long as the corresponding context is made current
@@ -6647,30 +6864,30 @@
     void readOffScreenBuffer(Canvas3D cv, Context ctx, int format, int dataType, Object data, int width, int height) {
         if (VERBOSE) System.err.println("JoglPipeline.readOffScreenBuffer()");
 
-    	GLDrawable 				glDrawable  = ((JoglDrawable)cv.drawable).getGLDrawable();
-        GLCapabilitiesImmutable chosenCaps  = glDrawable.getChosenGLCapabilities();
-        GLFBODrawable 			fboDrawable = null;
+        GLDrawable glDrawable = ((JoglDrawable) cv.drawable).getGLDrawable();
+        GLCapabilitiesImmutable chosenCaps = glDrawable.getChosenGLCapabilities();
+        GLFBODrawable fboDrawable = null;
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         // If FBO
         if (chosenCaps.isFBO()) {
 
-        	fboDrawable = (GLFBODrawable)glDrawable;
+            fboDrawable = (GLFBODrawable) glDrawable;
+
+            if (chosenCaps.getDoubleBuffered()) {
+                // swap = resolve multisampling or flip back/front FBO
+                fboDrawable.swapBuffers();
+                // unbind texture render target, we read from FBO
+                gl.glBindTexture(GL.GL_TEXTURE_2D, 0);
+            }
 
-        	if (chosenCaps.getDoubleBuffered()) {
-	        	// swap = resolve multisampling or flip back/front FBO
-	        	fboDrawable.swapBuffers();
-	        	// unbind texture render target, we read from FBO
-	        	gl.glBindTexture(GL.GL_TEXTURE_2D, 0);
-        	}
-
-        	// bind FBO for reading pixel data
-        	// GL_FRONT = SamplingSinkFBO if double buffered and multisampled
-        	// GL_FRONT if double buffered ( = GL_BAck before swap was called)
-        	// GL_FRONT = GL_BACK if single buffered (single FBO)
+            // bind FBO for reading pixel data
+            // GL_FRONT = SamplingSinkFBO if double buffered and multisampled
+            // GL_FRONT if double buffered ( = GL_BAck before swap was called)
+            // GL_FRONT = GL_BACK if single buffered (single FBO)
 
-        	fboDrawable.getFBObject( GL.GL_FRONT ).bind(gl);
+            fboDrawable.getFBObject(GL.GL_FRONT).bind(gl);
         }
         // else pbuffer
 
@@ -6679,7 +6896,7 @@
 
         int type = 0;
 
-        if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
+        if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_BUFFER)) {
 
             switch (format) {
@@ -6690,7 +6907,7 @@
                 case ImageComponentRetained.TYPE_BYTE_RGB:
                     type = GL.GL_RGB;
                     break;
-                    // GL_ABGR_EXT
+                // GL_ABGR_EXT
                 case ImageComponentRetained.TYPE_BYTE_ABGR:
                     if (gl.isExtensionAvailable("GL_EXT_abgr")) { // If false, should never come here!
                         type = GL2.GL_ABGR_EXT;
@@ -6703,7 +6920,7 @@
                     type = GL.GL_RGBA;
                     break;
 
-                    /* This method only supports 3 and 4 components formats and BYTE types. */
+                /* This method only supports 3 and 4 components formats and BYTE types. */
                 case ImageComponentRetained.TYPE_BYTE_LA:
                 case ImageComponentRetained.TYPE_BYTE_GRAY:
                 case ImageComponentRetained.TYPE_USHORT_GRAY:
@@ -6716,8 +6933,7 @@
 
             gl.glReadPixels(0, 0, width, height, type, GL.GL_UNSIGNED_BYTE, ByteBuffer.wrap((byte[]) data));
 
-        }
-        else if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
+        } else if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_BUFFER)) {
 
             int intType = GL2.GL_UNSIGNED_INT_8_8_8_8;
